#pragma once

#include "Core/PrimeHack/PrimeMod.h"
#include <VideoCommon/OnScreenDisplay.h>

namespace prime {
class Invulnerability : public PrimeMod {
public:
  void run_mod(Game game, Region region) override {}
  bool init_mod(Game game, Region region) override {
    u8 version = read8(0x80000007);

    switch (game) {
    case Game::PRIME_1:
      if (region == Region::NTSC_U) {
        add_code_change(0x80186408, 0x3863b6d8);
        add_code_change(0x80186414, 0x3863b6d8);
      }
      else if (region == Region::PAL) {
        add_code_change(0x801866a0, 0x3863f618);
        add_code_change(0x801866ac, 0x3863f618);
      }
      else { // region == Region::NTSC-J
        add_code_change(0x80186F88, 0x3863b958);
        add_code_change(0x80186F94, 0x3863b958);
      }
      break;
    case Game::PRIME_1_GCN:
      if (region == Region::NTSC_U) {
        if (version == 0) {
          add_code_change(0x80011d3c, 0x3863d780);
          add_code_change(0x80011d48, 0x3863d780);
        }
      }
      else if (region == Region::PAL) {
        add_code_change(0x80012670, 0x3863f820);
        add_code_change(0x8001267c, 0x3863f820);
      }
      break;
    case Game::PRIME_2:
      if (region == Region::NTSC_U) {
        add_code_change(0x8014baa4, 0x3c60804e);
        add_code_change(0x8014baa8, 0x38633508);
        add_code_change(0x8014baac, 0x4e800020);
      }
      else if (region == Region::PAL) {
        add_code_change(0x8014d218, 0x3c60804f);
        add_code_change(0x8014d21c, 0x3863a958);
        add_code_change(0x8014d220, 0x4e800020);
      }
      else {  // region == Region::NTSC-J
        add_code_change(0x8014b0ac, 0x3c60804e);
        add_code_change(0x8014b0b0, 0x38633cf8);
        add_code_change(0x8014b0b4, 0x4e800020);
      }
      break;
    case Game::PRIME_2_GCN:
      if (region == Region::NTSC_U) {
        add_code_change(0x8000ec08, 0x3c60803d);
        add_code_change(0x8000ec0c, 0x6063aa28);
        add_code_change(0x8000ec10, 0x4e800020);
      }
      else if (region == Region::PAL) {
        add_code_change(0x8000ec4c, 0x3c60803d);
        add_code_change(0x8000ec50, 0x6063bc48);
        add_code_change(0x8000ec54, 0x4e800020);
      }
    }
    return true;
  }        

  void on_state_change(ModState old_state) override {
    if (GetHackManager()->get_active_game() != Game::PRIME_3) {
      if (mod_state() != old_state)
        OSD::AddMessage(StringFromFormat("Invulnerability: %s", mod_state() == ModState::ENABLED ? "Enabled" : "Disabled"));
    }
  }
};
}
